program = require "commander"
childProcess = require "child_process"
util = require "util"

# Streamed output
executeCommand = (command, callbacks = null) ->
  parts = command.split " "
  command = parts.shift()
  args = parts
  
  spawnedProcess = childProcess.spawn command, args
  
  spawnedProcess.stdout.setEncoding "utf8"
  spawnedProcess.stdout.on "data", (data) -> process.stdout.write data
  
  spawnedProcess.stderr.setEncoding "utf8"
  spawnedProcess.stderr.on "data", (data) -> process.stdout.write data
  
  if callbacks?.exit?
    spawnedProcess.on "exit", exitCallback
  
# Buffered output
runCommand = (command) ->
  spawnedProcess = childProcess.exec command, encoding: "utf8", (error, stdout, stderr) ->
    process.stdout.write error if error isnt null
    process.stdout.write stdout if stdout isnt null
    process.stdout.write stderr if stderr isnt null
    
# Buffered output
runFile = (file) ->
  parts = file.split " "
  file = parts.shift()
  args = parts
  spawnedProcess = childProcess.execFile file, args, encoding: "utf8", (error, stdout, stderr) ->
    console.log error if error isnt null
    console.log stdout if stdout isnt null
    console.log stderr if stderr isnt null
  
program
  .version("0.0.1")
  .option("-C, --chdir <path>", "change the working directory")
  .option("-c, --config <path>", "set config path. defaults to ./deploy.conf")
  .option("-T, --no-tests", "ignore test hook")
  
program
  .command("server")
  .description("start server")
  .action (args) ->
    Server = require("../lib/yiu-cli").Server
    
    server = new Server
      name: "yobiutil"
      debug: on
      
    server.start()
    
program
  .command("init")
  .description("initialize application")
  .action (mode)->
    console.log mode
    executeCommand "ls -la"
    
program
  .command("test")
  .description("run tests")
  .action ->
    process.chdir __dirname + "/.."
    executeCommand "node test/all.js"
    
program
  .command("*")
  .description("deploy the given env")
  .action (env)->
    console.log "deploying \"%s\"", env
    
program.parse process.argv